#ifndef GGAF_DX_MORPHMESHACTOR_H_
#define GGAF_DX_MORPHMESHACTOR_H_
#include "GgafDxCommonHeader.h"
#include "jp/ggaf/dx/actor/supporter/Morpher.hpp"
#include "jp/ggaf/dx/actor/supporter/MorpherAssistantA.hpp"
#include "jp/ggaf/dx/actor/FigureActor.h"

namespace GgafDx {

/**
 * [tbVAN^[.
 * FigureActor pAXt@C`̃bV\@\y<BR>
 * [tAj[V@\AN^[<BR>
 * @version 1.00
 * @since 2009/05/08
 * @author Masatoshi Tsuge
 */
class MorphMeshActor : public FigureActor {

private:
    /** [tBOxIuWFNg */
    Morpher<MorphMeshActor>* const _pMorpher;

public:
    /** [r][t^[Qbg(f̃Rs[l) */
    int _morph_target_num;
    /** [r]f */
    MorphMeshModel* const _pMorphMeshModel;
    /** [r]GtFNg */
    MorphMeshEffect* const _pMorphMeshEffect;
    /** [r/w][t^[Qbg̏d(0.0 ` 1.0) */
    float _weight[MAX_MORPH_TARGET+1]; //[0]͖gpA[1]`[6][t^[Qbg1`6̏d

public:
    /**
     * RXgN^ .
     * @param prm_name AN^[́ifobOOŕ\AȂłǂj
     * @param prm_model_id f`A ".x" Xt@CɂȂ邱ƁB
     * @param prm_effect_id GtFNg`B ".fx" ăGtFNgt@CɂȂ邱ƁB
     * @param prm_technique GtFNg̃eNjbN
     * @param prm_pChecker gp`FbJ[IuWFNgi`FbJ[gpnullptrł悢j
     * @return
     */
    MorphMeshActor(const char* prm_name,
                   const char* prm_model_id,
                   const char* prm_effect_id,
                   const char* prm_technique,
                   Checker* prm_pChecker );

    /**
     * ʌppRXgN^
     * @param prm_name AN^[́iCӁj
     * @param prm_model_id f`
     * @param prm_model_type f^Cv
     * @param prm_effect_id GtFNg`
     * @param prm_effect_type GtFNg^Cv
     * @param prm_technique GtFNg̃eNjbN
     * @param prm_pChecker gp`FbJ[IuWFNgi`FbJ[gpnullptrł悢j
     * @return
     */
    MorphMeshActor(const char* prm_name,
                   const char* prm_model_id,
                   const char prm_model_type,
                   const char* prm_effect_id,
                   const char prm_effect_type,
                   const char* prm_technique,
                   Checker* prm_pChecker);

    virtual void processDraw() override;

    /**
     * [t^[QbgbV擾
     * @return [t^[QbgbV
     */
    int getMorphTergetNum();

    /**
     * [t^[Qbg̏d݂𒼐ڎw .
     * @param prm_target_mesh_no [t^[QbgbVNO(1 `)
     * @param prm_weight d d0.0`1.0Bȏ\
     */
    void setMorphWeight(int prm_target_mesh_no, float prm_weight);

    /**
     * S[t^[Qbg̏d݂𒼐ڎw
     * @param prm_target_mesh_no d0.0`1.0Bȏ\
     */
    void setMorphWeight(float prm_weight);

    float getMorphWeight(int prm_target_mesh_no);

    void addMorphWeight(int prm_target_mesh_no, float prm_add_weight);

    inline Morpher<MorphMeshActor>* getMorpher() {
        return _pMorpher;
    }

    virtual ~MorphMeshActor (); //fXgN^
};

}
#endif /*GGAF_DX_MORPHMESHACTOR_H_*/
