#ifndef GGAF_LIB_DEFAULTCAMERA_H_
#define GGAF_LIB_DEFAULTCAMERA_H_
#include "GgafLibCommonHeader.h"
#include "jp/ggaf/dx/actor/camera/Camera.h"

namespace GgafLib {

/**
 * W̃J.
 * @version 1.00
 * @since 2010/10/22
 * @author Masatoshi Tsuge
 */
class DefaultCamera : public GgafDx::Camera {

public:
    coord tx_, ty_, tz_;

public:
    DefaultCamera(const char* prm_name, double prm_rad_fovX, double prm_dep);
    DefaultCamera(const char* prm_name, double prm_rad_fovX);
    DefaultCamera(const char* prm_name);

    virtual void processJudgement() override {
    }

    virtual void processPreDraw() override {
    }

    virtual void processDraw() override {
    }

    virtual void processAfterDraw() override {
    }

    virtual void onCatchEvent(hashval prm_no, void* prm_pSource) override {
    }

    virtual void processFinal() override {
    }

    virtual void onHit(const GgafCore::Actor* prm_pOtherActor) override {
    }

    virtual GgafDx::CameraViewPoint* createCameraViewPoint() override;

    virtual GgafDx::CameraUpVector* createCameraUpVector() override;
    virtual void initialize() override;

    virtual void processBehavior() override;

    /**
     * J_xNg˂hʔԍ擾܂ .
     * @return J_xNg˂hʔԍ(1`26)
     */
    dir26 getVpDirNo();

    /**
     * JwʒuɊ炩ړ܂B .
     * @param tx
     * @param ty
     * @param tz
     * @param t vt[
     */
    void slideMvTo(coord tx, coord ty, coord tz, frame t, float prm_p1, float prm_p2);

    void slideMvTo(coord tx, coord ty, coord tz, frame t,
                   float prm_x_p1, float prm_y_p1, float prm_z_p1);
    /**
     * Jw̃AN^[̈ʒuɊ炩ړ܂B .
     * @param pTarget
     * @param t vt[
     */
    void slideMvTo(GgafDx::GeometricActor* pTarget, frame t, float prm_p1, float prm_p2);
    void slideMvTo(GgafDx::GeometricActor* pTarget, frame t,
            float prm_x_p1, float prm_y_p1, float prm_z_p1);

    bool isSliding();

    virtual ~DefaultCamera(); //fXgN^
};

}
#endif /*GGAF_LIB_DEFAULTCAMERA_H_*/
