#ifndef GGAF_LIB_LASERCHIPDEPOSITORY_H_
#define GGAF_LIB_LASERCHIPDEPOSITORY_H_
#include "GgafLibCommonHeader.h"
#include "jp/ggaf/core/actor/ex/ActorDepository.h"

#include "jp/ggaf/lib/actor/laserchip/LaserChip.h"

namespace GgafLib {

/**
 * [UP{([U[`bvg܂킵ǗNXB) .
 * new  appendChild \bh LaserChipCX^XDȌo^ĂB<BR>
 * new  initialize()܂ŁA͐ύXLȃp[^<BR>
 * E_num_chip_interval EEEe؂t[iftHg:20j<BR>
 * E_pSeConnection_Laser EEE [U[`bvˎSEiftHg:nullptrj<BR>
 * <gp><BR>
 * <code><pre>
 *
 * ----- OiRXgN^łP{쐬j --------------
 *
 * LaserChipDepository* pLaserDepo = new LaserChipDepository("MyLaserDp");  //{f|WgNX𐶐
 * MyStraightLaserChip* pChip;                    //MyStraightLaserChip  LaserChip pNXB
 * for (int i = 0; i < 60; i++) {                 //1{60̃`bvō\
 *     pChip = new MyStraightLaserChip("chip");   //LaserChip NXpEIuWFNg쐬
 *     pChip->setSource(this);                    //p LaserChip ŗL̐ݒ{B̗̓C_[̂߂̔ˌݒB
 *     pLaserDepo->appendChild(pChip);             //{f|Wg LaserChip IuWFNgo^(qɏ)
 * }
 * pLaserDepo->config(40, 25);                    //LaserChip ̍őAAe؂t[ݒB
 * appendGroupChild(_pLaserChipDepo);                  //f|Wĝ\ɂ邽߁AɏB
 *
 *
 * ----- ˏiZL[ςȂŔ˗j --------------
 *
 * if (GgafDx::Input::isPressedKey(DIK_Z)) {   //ZL[
 *     pLaserDepo->dispatch();                    //dispatch()邱ƂŁAo^ꂽMyStraightLaserChipBB
 * }
 *
 * </pre></code>
 */
class LaserChipDepository : public GgafCore::ActorDepository {
    friend class LaserChip;

public:
    /** [r]ێ郌[U[`bv(ǂݎp) */
    int _num_chip_max;
    /** [r][U[`bv(ǂݎp) */
    int _num_chip_active;
    /** [r][U[`bvؒfꂽtO(ǂݎpAtrue=AˏԂ͎ՒfĂ/false=Aˏ) */
    bool _is_tear_laser;
    /** [r]OiOt[j擾ꂽ[U[`bv(ǂݎp) */
    LaserChip* _pChip_prev_dispatch;
    /** [r]OiOt[j擾ꂽ[U[`bv̎擾ꂽ_̊t[(ǂݎp) */
    frame _frame_of_behaving_prev_dispatch;
    /** [r][U[`bvA擾JEg(ǂݎp) */
    int _num_continual_dispatch_count;
    /** [r][U[`bvA擾JEg(ǂݎp) */
    int _num_interval_frame_count;

    /** [r/w]e؂Ɉڍs`bv̘A擾Biǂݏ^ftHgFappendChild() _num_chip_max ƓɂȂĂB */
    int _num_continual_dispatch_max;
    /** [r/w]e؂t[iǂݏ^ftHg=20j */
    int _num_chip_interval;
    /** [r]e؂̎A܂甭(dispatch()) o悤ɂ邩 */
    int _num_chip_dispatch_able;
    /** [r/w][U[ˎGtFNgBsv̏ꍇnullptrݒ肷 */
    GgafDx::FigureActor* _pEffectActor;

public:
    LaserChipDepository(const char* prm_name);

    /**
     * [U[ݒ肷 .
     * put((LaserChip*) Ń[U[`bvǉɐݒ肵Ă
     * @param prm_num_continual_dispatch_max Iɒe؂Ɉڍs`bv̘A擾B
     * @param prm_num_chip_interval e؂t[
     * @param prm_pEffectActor V[ςݔ˒GtFNg(svnullptr)B͌ĂьŁB
     */
    virtual void config(int prm_num_continual_dispatch_max,
                        uint32_t prm_num_chip_interval,
                        GgafDx::FigureActor* prm_pEffectActor = nullptr);

    virtual void processBehavior() override {
    }

    virtual void processFinal() override;

    /**
     * [U[`bv̎؂݁A؂łΎ擾ԂɂB .
     * XgbN؂A͒e؂ꒆ̏ꍇ͖߂ nullptr ԂB
     * 擾`bv̗pIꍇ sayonara() (inactivate()) sĂB
     * IɃXgbNɖ߂܂B
     * @return ؂ꂵ[U[`bvB؂łȂꍇnullptr
     */
    virtual LaserChip* dispatch(int prm_offset_frames = 1) override;

    /**
     * [U[`bvXgbN̒ǉ .
     * DȂǉĉB
     * ǉ΂قǋʐ؂ꂪɂB<br>
     * @param prm_pChild [U[`bv
     */
    virtual void put(GgafCore::Actor* prm_pChild) override;

    /**
     * Zbg̏ .
     * o[SinactivateImmed()܂B
     */
    virtual void onReset() override;

    virtual ~LaserChipDepository();

};

}
#endif /*GGAF_LIB_LASERCHIPDEPOSITORY_H_*/
