#include "GgafEffectConst.fxh"
////////////////////////////////////////////////////////////////////////////////
// ggaf CuAGgafDx::AniMeshModelpVF[_[
//
// author : Masatoshi Tsuge
// date:2009/03/06
////////////////////////////////////////////////////////////////////////////////

float4x4 g_matWorld;  //Worldϊs
float4x4 g_matView;   //Viewϊs
float4x4 g_matProj;   //ˉeϊs

float3 g_vecLightFrom_World; // Cg̕
float4 g_colLightAmbient;   // AmbienCgFiːFj
float4 g_colLightDiffuse;   // DiffuseCgFiːFj
float g_alpha_master;
float g_zf;
float4 g_colMaterialDiffuse;  //}eADiffuseːFƁAAmbienːF
float g_tex_blink_power;
float g_tex_blink_threshold;

//s0WX^̃Tvg(ŒpCvCɃZbgꂽeNX`VF[_[Ŏg)
sampler MyTextureSampler : register(s0);

//_VF[_[Ao͍\
struct OUT_VS
{
    float4 posModel_Proj    : POSITION;
    float2 uv     : TEXCOORD0;
    float4 color    : COLOR0;
};


///////////////////////////////////////////////////////////////////////////

//bVW_VF[_[
OUT_VS VS_DefaultD3DXAniMesh(
      float4 prm_posModel_Local    : POSITION,      // f̒_
      float3 prm_vecNormal_Local : NORMAL,        // f̒_̖@
      float2 prm_uv     : TEXCOORD0      // f̒_UV

) {
    OUT_VS out_vs = (OUT_VS)0;

    //_vZ
    out_vs.posModel_Proj = mul( mul( mul(prm_posModel_Local, g_matWorld), g_matView), g_matProj);  //World*View*ˉeϊ
    //UV͂̂܂
    out_vs.uv = prm_uv;

    //_J[vZ

    //@ World ϊĐK
    const float3 vecNormal_World = normalize(mul(prm_vecNormal_Local, g_matWorld));
    //@ƁADiffuseCg̓ςvZAʂɑ΂郉Cg̓ˊpɂ錸߂B
    float refl_power = dot(vecNormal_World, -g_vecLightFrom_World);
    //ς̒̕lgpāAn[tEo[g ŊgỦ͂s
    refl_power = refl_power * 0.5f + 0.5f;
    refl_power *= refl_power;
    //AmbientCgFADiffuseCgFADiffuseCgA}eAF lJ[쐬B
    out_vs.color = (g_colLightAmbient + (g_colLightDiffuse*refl_power)) * g_colMaterialDiffuse;
    //tHO
    out_vs.color.a = g_colMaterialDiffuse.a;
    if (out_vs.posModel_Proj.z > 0.6*g_zf) {   // ŉ̖ 2/3 肳ɉ̏ꍇXɓ
        out_vs.color.a *= (-3.0*(out_vs.posModel_Proj.z/g_zf) + 3.0);
    }
//    if (out_vs.posModel_Proj.z > g_zf*0.98) {
//        out_vs.posModel_Proj.z = g_zf*0.98; //{OZłA`邽0.9ȓɏ㏑A
//    }
    return out_vs;
}

//bVWsNZVF[_[ieNX`Lj
float4 PS_DefaultD3DXAniMesh(
    float2 prm_uv	  : TEXCOORD0,
    float4 prm_color    : COLOR0
) : COLOR  {
    //eNX`TvOĐF擾iF擾j
    const float4 colTex = tex2D( MyTextureSampler, prm_uv);
    float4 colOut = colTex * prm_color;

    //Blinkerl
    if (colTex.r >= g_tex_blink_threshold || colTex.g >= g_tex_blink_threshold || colTex.b >= g_tex_blink_threshold) {
        colOut *= g_tex_blink_power; //+ (colTex * g_tex_blink_power);
    }
    //}X^[
    colOut.a *= g_alpha_master;
    return colOut;
}

float4 PS_DefaultD3DXAniMesh2(
    float2 prm_uv	  : TEXCOORD0,
    float4 prm_color    : COLOR0
) : COLOR  {
    //eNX`TvOĐF擾iF擾j
    const float4 colTex = tex2D( MyTextureSampler, prm_uv);
    float4 colOut = colTex * prm_color;

    //Blinkerl
    if (colTex.r >= g_tex_blink_threshold || colTex.g >= g_tex_blink_threshold || colTex.b >= g_tex_blink_threshold) {
        colOut *= g_tex_blink_power; //+ (colTex * g_tex_blink_power);
    }
    //}X^[
    colOut.a *= g_alpha_master;
    return colOut;
}


technique DefaultD3DXAniMeshTechnique
{
    //pass P0ubVWVF[_[v
    //bV`悷
    //ylvfz
    //--- VS ---
    //E_ WorldAViewAˉe ϊ
    //E@ Worldϊ
    //--- PS ---
    //EDiffuseCgF
    //EAmbientCgF
    //ECg
    //EIuWFNg̃}eADiffuseˁiFAmbient˂Ƌʁj
    //EIuWFNg̃eNX`
    //EiDiffuse˃ƃeNX`̏Zj
    //ygpz
    //EeNX`݂s0WX^ɃoChĂ邱ƁB
    //yݒp[^z
    // float4x4 g_matWorld		:	Worldϊs
    // float4x4 g_matView		:	Viewϊs
    // float4x4 g_matProj		:	ˉeϊs
    // float3 g_vecLightFrom_World	:	Cg̕
    // float4 g_colLightAmbient	:	AmbienCgFiːFj
    // float4 g_colLightDiffuse	:	DiffuseCgFiːFj
    // float4 g_colMaterialDiffuse	:	}eADiffuseˁiAmbient˂Ƌʁj
    // s0WX^				:	2DeNX`
    pass P0 {
        AlphaBlendEnable = true;
        SeparateAlphaBlendEnable = false;
        SrcBlend  = SrcAlpha;
        DestBlend = InvSrcAlpha;
        BlendOp = Add;
        VertexShader = compile VS_VERSION VS_DefaultD3DXAniMesh();
        PixelShader  = compile PS_VERSION PS_DefaultD3DXAniMesh();
    }
}

technique DefaultD3DXAniMeshTechnique2
{
    pass P0 {
        AlphaBlendEnable = true;
        SeparateAlphaBlendEnable = false;
        SrcBlend  = SrcAlpha;
        DestBlend = InvSrcAlpha;
        BlendOp = Add;
        VertexShader = compile VS_VERSION VS_DefaultD3DXAniMesh();
        PixelShader  = compile PS_VERSION PS_DefaultD3DXAniMesh2();
    }
}


