#ifndef ENEMYERMIONE_H_
#define ENEMYERMIONE_H_
#include "VioletVreath.h"
#include "jp/gecchi/VioletVreath/actor/VvEnemyActor.hpp"
#include "jp/ggaf/lib/actor/DefaultMorphMeshActor.h"

#include "jp/gecchi/VioletVreath/actor/enemy/Ermione/EnemyErmioneArm.h"

namespace VioletVreath {

DECLARE_HASHVAL(EVENT_ERMIONE_SAYONARA);
DECLARE_HASHVAL(EVENT_ERMIONE_ENTRY_DONE);

/**
 * G@G~Il  .
 * O̐GɒbbIII
 * @version 1.00
 * @since 2012/11/05
 * @author Masatoshi Tsuge
 */
class EnemyErmione :
  public VvEnemyActor<GgafLib::DefaultMorphMeshActor> {
//class EnemyErmione : public VvEnemyActor<GgafLib::CubeMapMorphMeshActor> {

public:
    class Arm {
    public:
        angle pos_Rz_;
        angle pos_Ry_;
        EnemyErmioneArm** papArmPart_;
    public:
        Arm() : pos_Rz_(0),pos_Ry_(0),papArmPart_(nullptr) {}
        ~Arm() {
            GGAF_DELETEARR(papArmPart_);
        }
    };
    int num_arm_; //r̐
    int num_arm_part_;  //r̐ߐi3ȏj
    Arm* paArm_;

public:
    /**
     * RXgN^
     * @param prm_name
     * @return
     */
    EnemyErmione(const char* prm_name);

    void onCreateModel() override;

    /**
     * G~Il̏iCX^Xۏ؁j
     */
    void initialize() override;

    /**
     * G~IlANeBuɂȂuԂ̏ .
     */
    void onActive() override;

    /**
     * G~Il̐U镑 .
     */
    void processBehavior() override;

    /**
     * G~Il̐U镑̔菈 .
     */
    void processJudgement() override;

    /**
     * G~Il̏Փˎ .
     * @param prm_pOtherActor ՓˑΏ
     */
    void onHit(const GgafCore::Actor* prm_pOtherActor) override;


    void onInactive() override;
    void addArm(angle prm_rz, angle prm_ry);
    virtual ~EnemyErmione();
};

}
#endif /*ENEMYERMIONE_H_*/

