#ifndef ENEMYGLAJA_H_
#define ENEMYGLAJA_H_
#include "VioletVreath.h"
#include "jp/gecchi/VioletVreath/actor/VvEnemyActor.hpp"
#include "jp/ggaf/lib/actor/DefaultMorphMeshActor.h"

#include "jp/ggaf/dx/util/GeoElem.h"

namespace VioletVreath {

/**
 * G@O .
 * ^@ɂ悤B
 * |CƊʁXȂāArVƑeɕωĔłB
 * @version 1.00
 * @since 2013/08/19
 * @author Masatoshi Tsuge
 */
class EnemyGlaja : public VvEnemyActor<GgafLib::DefaultMorphMeshActor> {

public:
    DepositoryConnection* pConn_pShot_;
    GgafDx::GeoElem next_pos_;
    int num_fire_;

public:
    /**
     * RXgN^
     * @param prm_name
     * @return
     */
    EnemyGlaja(const char* prm_name);

    void onCreateModel() override;

    /**
     * ȌiCX^Xۏ؁j
     */
    void initialize() override;

    /**
     * OANeBuɂȂuԂ̏ .
     */
    void onActive() override;

    /**
     * O̐U镑 .
     */
    void processBehavior() override;

    /**
     * O̐U镑̔菈 .
     */
    void processJudgement() override;

    /**
     * ȌՓˎ .
     * @param prm_pOtherActor ՓˑΏ
     */
    void onHit(const GgafCore::Actor* prm_pOtherActor) override;

    void onInactive() override;

    static void onDispatchedShot(GgafDx::FigureActor* prm_pActor, int prm_dispatch_num, int prm_set_index, int prm_way_index);

    virtual ~EnemyGlaja();
};

}
#endif /*ENEMYGLAJA_H_*/

